unit udmPrincipal;

interface

uses
  System.SysUtils, System.Classes, Data.DBXDataSnap, IndyPeerImpl,
  Data.DBXCommon, Data.DB, Datasnap.DBClient, Datasnap.DSConnect, Data.SqlExpr,
  IniFiles, Vcl.Forms, Dialogs;

type
  TdmPrincipal = class(TDataModule)
    ServerConnection: TSQLConnection;
    dspcGlobal: TDSProviderConnection;
    cdsUsuarios: TClientDataSet;
    cdsUsuarioscodigo: TIntegerField;
    cdsUsuariosusuario: TStringField;
    cdsUsuariossenha: TStringField;
    cdsCadastro: TClientDataSet;
    cdsCadastronome: TStringField;
    cdsCadastroendereco: TStringField;
    cdsCadastrobairro: TStringField;
    cdsCadastrocidade: TStringField;
    cdsCadastrouf: TStringField;
    procedure DataModuleCreate(Sender: TObject);
    procedure cdsCadastroAfterPost(DataSet: TDataSet);
    procedure cdsCadastroAfterDelete(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    vUsuario : String;
  end;

var
  dmPrincipal: TdmPrincipal;

implementation

{%CLASSGROUP 'System.Classes.TPersistent'}

uses uProxy, uLogin;

{$R *.dfm}

procedure TdmPrincipal.cdsCadastroAfterDelete(DataSet: TDataSet);
begin
  cdsCadastro.ApplyUpdates(0);
end;

procedure TdmPrincipal.cdsCadastroAfterPost(DataSet: TDataSet);
begin
  cdsCadastro.ApplyUpdates(0);
end;

procedure TdmPrincipal.DataModuleCreate(Sender: TObject);
var
  ClientConfig:   TIniFile;  // Declarao uses: IniFiles
  CaminhoIni, vHostName, vPorta, vCliente: String;
  scGlogal : TsmGlobalClient;
begin
  CaminhoIni := ExtractFilePath(Application.ExeName) + 'ClientConfig.ini';
                   // Declarao uses: Vcl.Forms
  try
    ClientConfig := TIniFile.Create(CaminhoIni);
    vHostName := ClientConfig.ReadString('CONFIGURACOES', 'HOSTNAME', '');
    vPorta := ClientConfig.ReadString('CONFIGURACOES', 'PORTA', '');
    vCliente := ClientConfig.ReadString('CONFIGURACOES', 'CLIENTE', '');

    ServerConnection.Params.Values['HostName'] := vHostName;
    ServerConnection.Params.Values['Port'] := vPorta;
    ServerConnection.Open;

    scGlogal := TsmGlobalClient.Create(ServerConnection.DBXConnection);
    If not scGlogal.DefineBanco(vCliente) Then Begin
      MessageDlg('Ocorreu um erro ao tentar se conectar ao Banco de Dados!!!',
          mtInformation, [mbOK], 0, mbOK);
      scGlogal.Free;
      Application.Terminate;
    End;
  except
    MessageDlg('Ocorreu um erro ao tentar se conectar ao Servidor de Aplicao!!!',
        mtInformation, [mbOK], 0, mbOK);
    Application.Terminate;
  end;
  ClientConfig.Free;
  frmLogin := TfrmLogin.Create(Self);
  try
    frmLogin.ShowModal;
    If frmLogin.Tag = 1 Then Begin
      If not scGlogal.DefineUsuario(vUsuario) Then Begin  // vUsuario foi declarada em public
        MessageDlg('Ocorreu um erro ao tentar se conectar ao Banco de Dados!!!',
            mtInformation, [mbOK], 0, mbOK);
        scGlogal.Free;
        ServerConnection.Close;
        Application.Terminate;
      End;
    End Else Begin
      scGlogal.Free;
      ServerConnection.Close;
      Exit;
    End;
    cdsCadastro.Open;
  except
    scGlogal.Free;
    frmLogin.Tag := 0;
    ServerConnection.Close;
    Exit;
  end;
  scGlogal.Free;
end;

end.
