unit usmGlobal;

interface

uses System.SysUtils, System.Classes, Datasnap.DSServer, Datasnap.DSAuth,
  Data.DBXMySQL, Data.FMTBcd, Datasnap.DBClient, Datasnap.Provider, Data.DB,
  Data.SqlExpr;

type
  TsmGlobal = class(TDSServerModule)
    sqlcGeral: TSQLConnection;
    sdsClientes: TSQLDataSet;
    sdsClientescnpj: TStringField;
    sdsClientesbanco_dados: TStringField;
    dspClientes: TDataSetProvider;
    cdsClientes: TClientDataSet;
    cdsClientescnpj: TStringField;
    cdsClientesbanco_dados: TStringField;
    sdsUsuarios: TSQLDataSet;
    sdsUsuarioscodigo: TIntegerField;
    sdsUsuariosusuario: TStringField;
    sdsUsuariossenha: TStringField;
    dspUsuarios: TDataSetProvider;
    sdsCadastro: TSQLDataSet;
    dspCadastro: TDataSetProvider;
    sdsCadastronome: TStringField;
    sdsCadastroendereco: TStringField;
    sdsCadastrobairro: TStringField;
    sdsCadastrocidade: TStringField;
    sdsCadastrouf: TStringField;
    procedure sdsUsuariosBeforeOpen(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    function DefineBanco(CNPJ : String) : Boolean;
    function DefineUsuario(User : String) : Boolean;
  end;

implementation

{$R *.dfm}

uses uServerContainer;

{ TsmGlobal }

function TsmGlobal.DefineBanco(CNPJ: String): Boolean;
begin
  cdsClientes.Close;
  cdsClientes.Params[0].AsString := CNPJ;
  cdsClientes.Open;
  If cdsClientes.RecordCount = 1 Then Begin
    Result := ServerContainer.CreateConnection(cdsClientesbanco_dados.AsString);
    cdsClientes.Close;
  End Else
    Result := False;
end;

function TsmGlobal.DefineUsuario(User: String): Boolean;
begin
  Result := ServerContainer.CreateUserData(User);
end;

procedure TsmGlobal.sdsUsuariosBeforeOpen(DataSet: TDataSet);
begin
  TSQLDataSet(DataSet).SQLConnection := ServerContainer.GetConnection;
end;

end.

