unit udmDados;

interface

uses
  System.SysUtils, System.Classes, Data.DBXOracle, Data.DB, Data.SqlExpr,
  DBXDevartOracle, Data.DBXMSSQL, Data.FMTBcd, Data.DBXDataSnap,
  IndyPeerImpl, Data.DBXCommon, DBClient, DSConnect, Provider
{$IFDEF DATASNAP}
  , prxExemplo, DBXCompressionFilter
{$ELSE}
 , udmDadosServer
{$ENDIF}
  ;

type
  TdmDados = class(TDataModule)
    cdsPerson: TClientDataSet;
    SQLConnection1: TSQLConnection;
    DSProviderdmDados: TDSProviderConnection;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
{$IFDEF DATASNAP}
    procedure CriaProxy;
{$ELSE}
    procedure cdsPadraoBeforeOpen(DataSet: TDataSet);
{$ENDIF}
  public
    { Public declarations }
{$IFDEF DATASNAP}
    xPbDadosSC: TdmDadosServerClient;
{$ENDIF}
  end;

var
  dmDados: TdmDados;

implementation

{%CLASSGROUP 'System.Classes.TPersistent'}

{$R *.dfm}

procedure TdmDados.DataModuleCreate(Sender: TObject);
var
  iLc: integer;
begin
{$IFDEF DATASNAP}
  SqlConnection1.Open;
  for iLc := 0 to ComponentCount - 1 do
  begin
    if (Components[iLc] is TClientDataSet) then
    begin
      (Components[iLc] as TClientDataSet).RemoteServer := DSProviderdmDados;
    end;
  end;
  CriaProxy;
{$ELSE}
  dmDadosServer := TdmDadosServer.Create(Self);
  for iLc := 0 to ComponentCount - 1 do
  begin
    if (Components[iLc] is TClientDataSet) then
    begin
      (Components[iLc] as TClientDataSet).RemoteServer := nil;
      if Not Assigned((Components[iLc] as TClientDataSet).BeforeOpen) then
        (Components[iLc] as TClientDataSet).BeforeOpen := cdsPadraoBeforeOpen;
    end;
  end;//for
{$ENDIF}
end;

{$IFDEF DATASNAP}
procedure TdmDados.CriaProxy;
begin
  xPbDadosSC := TdmDadosServerClient.Create(SqlConnection1.DBXConnection);
end;
{$ELSE}
procedure TdmDados.cdsPadraoBeforeOpen(DataSet: TDataSet);
begin
  (DataSet as TClientDataSet).SetProvider(dmDadosServer.FindComponent(
  StringReplace((DataSet as TClientDataSet).Name,'cds','dsp',[rfIgnoreCase]))
  as TDataSetProvider);
end;
{$ENDIF}

end.
